//------------------------------------------------------------------------------
//
//  npkml.h
//
// ANTZ - 3D data viewer with realtime real-world interaction based on NPE.
//
// ANTZ is hosted at http://temporalzone.com and NPE at http://neuralphysics.org
//
// Written in 2010-2012 by Shane Saxon - contact@saxondigital.net
//
// Additional code contributed by: Mark Buchanan and Lucas Erickson.
//
// To the extent possible under law, the author(s) have dedicated all copyright 
// and related and neighboring rights to this software to the public domain
// worldwide. This software is distributed without any warranty.
//
// Released under the CC0 license, which is GPL compatible.
//
// You should have received a copy of the CC0 Public Domain Dedication along
// with this software (license file named COPYING.txt). If not, see
// http://creativecommons.org/publicdomain/zero/1.0/
//
//------------------------------------------------------------------------------

#ifndef NPKML_H_
#define NPKML_H_


#include <stdio.h>
#include "../../npdata.h"


//------------------------------------------------------------------------------
void npInitKML (void* dataRef);
void npCloseKML (void* dataRef);

// these functions wrap the standard C file methods on Linux, MSW and OSX
// opens or creates the file in the specified mode "rb+" read/write binary..
FILE* npOpenKML (const char* fileName, const char* mode, void* dataRef);

FILE* npKMLNew (const char* fileName, const char* mode, void* dataRef);

FILE* npKMLDialog (const char* fileName, int dialogType, void* dataRef);

// if not saved then opens SaveAs dialog before reseting app
void npKMLClose (void* dataRef);

// wrappers for fread(), fwrite() and rewind()
//void npReadFile (void* writeBuffer, int wordSize, int size, void* dataRef);
int npReadKML (void* readBuffer, int elementSize, int elementCount, 
				 FILE* file, void* dataRef);
int npWriteKML (const void* str, int wordSize, int size, FILE* file, void* dataRef);

// 
void npSaveKML (FILE* file, void* dataRef);

void npImportKML (FILE* file, int type, void* dataRef);
void npExportKML (FILE* file, void* dataRef);

// file and directory management
void npGetAttribKML (int size, void* dataRef);
void npSetAttribKML (int size, void* dataRef);

void npTestKML (void* fileName, int wordSize, int size, void* dataRef);


#endif